;*****************************************************************************
;        title     "n/a"

    PROCESSOR 16f628A
    #define _XTAL_FREQ .4000000

    #include "p16F628A.inc"
    #include "macro.inc"

    errorlevel -302

    ;__CONFIG   _CP_OFF & _DATA_CP_OFF & _LVP_OFF & _BOREN_OFF & _MCLRE_ON & _WDT_OFF & _PWRTE_ON & _XT_OSC

        cblock 0x20
        LCD_BUFF, LCD_MODE, COUNTER_MAIN, DELAY_A, DELAY_B, TEMP
        endc

;*****************************************************************************

    #define LCD_EN	PORTB,5
    #define LCD_CK	PORTB,6
    #define LCD_DT	PORTB,7
    #define LCD_RS	LCD_DT

;****************************************************************************

        org 0x000
        clrf    PCLATH
        goto    main_app


        org 0x004
        ; isr here
        retfie

main_app
        call    _mcu_init
        call    _lcd_init
        call    _lcd_hello_scr

loop    goto    loop

_mcu_init
        banksel INTCON            ; Disable Interrupts
        clrf    INTCON            ; GIE, PEIE,INTE,RBIE,T0IE
        banksel PIE1
        clrf    PIE1
        banksel PIR1
        clrf    PIR1
        banksel CMCON             ; Disable comparators
        MOVLF   b'00000111', CMCON

        banksel TRISB
        MOVLF   b'00011111', TRISB

        banksel PORTB
        clrf    PORTB
        return



_lcd_init
        LCD_INST b'00110000'      ; power-up init
        DELAY_MS .5
        LCD_INST b'00110000'
        DELAY_MS .1
        LCD_INST b'00110000'      ; 8 bit interface
        DELAY_MS .1
                                  ; standard init
        LCD_INST b'00111000'      ; 8 bit, 2 lines, 58 font
        LCD_INST b'00001000'      ; Display OFF, Cursor OFF, blink OFF
        LCD_INST b'00001100'      ; Display ON, Cursor OFF, blink OFF
        LCD_INST b'00000001'      ; clear Display
        DELAY_MS .3               ; BIG delay after clear display / return home       <-- TAKE CARE !!!
        LCD_INST b'00000110'      ; Increment after write, no display shift
        return



_lcd_hello_scr
        LCD_INST 0x80             ; Line 1, Row 1

        LCD_DATA 'H'
        LCD_DATA 'e'
        LCD_DATA 'l'
        LCD_DATA 'l'
        LCD_DATA 'o'
        LCD_DATA '!'
        return



_lcd_data
        MOVLF .8, COUNTER_MAIN

send_bit
        bsf     LCD_DT
        btfss   LCD_BUFF,7
        bcf     LCD_DT
        bsf     LCD_CK
        bcf     LCD_CK
        rlf     LCD_BUFF,f

        decfsz  COUNTER_MAIN,f
        goto    send_bit

        bsf     LCD_RS            ; data mode
        btfss   LCD_MODE,0
        bcf     LCD_RS            ; inst mode

        bsf     LCD_EN
        nop
        bcf     LCD_EN

        DELAY_US .50
        return

_delay_1ms
        DELAY_US .248
        DELAY_US .248
        DELAY_US .248
        DELAY_US .248
        return

        end
